// EvidenceAut.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "EvidenceAut.h"

// POZNAMKA:
// Rikal jsem, ze inicializovat lze jen STATICKE nebo GLOBALNI pole a struktury.
// To platilo v Ccku drive, nyni je mozno inicializovat jakekoli...
// Jako v prikladu dole, pole Auto a[3] je normalni promenna vytvarena na zasobniku,
// a inicializujeme ji rovnou.

int main()
{
	// inicializujeme pole trech struktur typu Auto
	Auto a[3] = 
	{
		{ cervena, Skoda, "AKL1245" },
		{ bila, Audi, "ACJ9854" },
		{ modra, Dacia, "HKI8754" }
	};

	// a tyto tri struktury zapiseme do souboru.

	// nejprve ho otevreme pro binarni zapis
	FILE * fw = fopen("auta.bin", "wb");

	// sizeof(a)/sizeof(a[0]) spocita pocet prvku v poli, protoze sizeof(a) je velikost
	// celeho pole a sizeof(a[0]) je velikost jedne (prvni) polozky.
	for (int i = 0; i < sizeof(a)/sizeof(a[0]); i++)
	{
		// vypiseme co zapisujeme
		puts("Zapisuji:");
		printf("Barva: %d\n", a[i].barva);
		printf("Znacka: %d\n", a[i].znacka);
		printf("SPZ: %s\n", a[i].spz);
		puts("");

		// a zapiseme. Prvni parametr je ukazatel do pameti, kde je to, co chceme zapsat,
		// a[i] znamena zapisovanou strukturu, tak musime pomoci & zjistit jeji adresu.
		fwrite(&a[i], sizeof(Auto), 1, fw);
	}

	// a soubor zavreme
	fclose(fw);


	// nasleduje ukazka posunovani se v souboru. Zkusime nacist rovnou treti zaznam.

	// soubor znovu otevreme
	FILE * fr = fopen("auta.bin", "rb");
	// a posuneme se na treti - tj. prvni dve preskocime.
	fseek(fr, sizeof(Auto) * 2, SEEK_SET);

	// rezervujeme si pamet na strukturu Auto
	Auto treti;
	// a zapiseme do ni to, co se nacte ze souboru.
	fread(&treti, sizeof(Auto), 1, fr);
	// a soubor zavreme
	fclose(fr);


	// nyni vypiseme to co jsme nacetli, abychom mohli zkontrolovat, ze se nacetl
	// skutecne treti zaznam.
	puts("Nactene rovnou treti:");
	printf("Barva: %d\n",treti.barva);
	printf("Znacka: %d\n", treti.znacka);
	printf("SPZ: %s\n", treti.spz);


	getch();
	return 0;
}

